org.cpsolver.exam.model

## Enum ExamDistributionConstraint.DistributionType

- java.lang.Object
- - java.lang.Enum<ExamDistributionConstraint.DistributionType>
  - - org.cpsolver.exam.model.ExamDistributionConstraint.DistributionType

- All Implemented Interfaces:
    Serializable, Comparable<ExamDistributionConstraint.DistributionType>
  Enclosing class:
    ExamDistributionConstraint

      public static enum ExamDistributionConstraint.DistributionType
      extends Enum<ExamDistributionConstraint.DistributionType>

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `DifferentDay` Different day constraint type
    `DifferentPeriod` Different period constraint type
    `DifferentRoom` Different room constraint type
    `Precedence` Precedence constraint type
    `PrecedenceRev` Precedence constraint type (reverse order)
    `SameDay` Same day constraint type
    `SamePeriod` Same period constraint type
    `SameRoom` Same room constraint type

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `getReference()`
    `String` | `getUniTimeReference()`
    `boolean` | `isPeriodRelated()`
    `boolean` | `isRoomRelated()`
    `boolean` | `isSatisfied(ExamPeriod first, ExamPeriod second)`
    `boolean` | `isSatisfied(ExamPlacement first, ExamPlacement second)`
    `boolean` | `isSatisfied(ExamPlacement first, ExamRoomPlacement second)`
    `boolean` | `isUniTimeNegative()`
    `static ExamDistributionConstraint.DistributionType` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static ExamDistributionConstraint.DistributionType[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### SameRoom

          public static final ExamDistributionConstraint.DistributionType SameRoom

      Same room constraint type

    - #### DifferentRoom

          public static final ExamDistributionConstraint.DistributionType DifferentRoom

      Different room constraint type

    - #### SamePeriod

          public static final ExamDistributionConstraint.DistributionType SamePeriod

      Same period constraint type

    - #### DifferentPeriod

          public static final ExamDistributionConstraint.DistributionType DifferentPeriod

      Different period constraint type

    - #### Precedence

          public static final ExamDistributionConstraint.DistributionType Precedence

      Precedence constraint type

    - #### PrecedenceRev

          public static final ExamDistributionConstraint.DistributionType PrecedenceRev

      Precedence constraint type (reverse order)

    - #### SameDay

          public static final ExamDistributionConstraint.DistributionType SameDay

      Same day constraint type

    - #### DifferentDay

          public static final ExamDistributionConstraint.DistributionType DifferentDay

      Different day constraint type

  - ### Method Detail

    - #### values

          public static ExamDistributionConstraint.DistributionType[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (ExamDistributionConstraint.DistributionType c : ExamDistributionConstraint.DistributionType.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static ExamDistributionConstraint.DistributionType valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### getReference

          public String getReference()

    - #### isSatisfied

          public boolean isSatisfied(ExamPlacement first,
                                     ExamPlacement second)

    - #### isRoomRelated

          public boolean isRoomRelated()

    - #### isPeriodRelated

          public boolean isPeriodRelated()

    - #### isSatisfied

          public boolean isSatisfied(ExamPeriod first,
                                     ExamPeriod second)

    - #### isSatisfied

          public boolean isSatisfied(ExamPlacement first,
                                     ExamRoomPlacement second)

    - #### getUniTimeReference

          public String getUniTimeReference()

    - #### isUniTimeNegative

          public boolean isUniTimeNegative()